/*
Author : Aakash Gupta
Description : Test class for BRReportsFilterCtrl
Date : 28 February, 2018

*/

@isTest
private class TestBRReportsFilterCtrl{
    @isTest static void cpgFilterTest1() {
    
        Workspace__c workSpaceObj = new Workspace__c();
        workSpaceObj.Name = 'Workspace 1';
        workSpaceObj.Workspace_Description__c='Workspace 1';
        workSpaceObj.Workspace_Start_Date__c=Date.parse('1/1/2014');
        
        insert workSpaceObj;
        
        Scenario__c scenarioObj = new Scenario__c ();
        scenarioObj.Workspace__c= workSpaceObj.id;
        insert scenarioObj;
        
        Scenario_Rule_Instance_Details__c sceRuleInsDetObj = new Scenario_Rule_Instance_Details__c ();
        sceRuleInsDetObj.Scenario_Id__c= scenarioObj.id;
       // sceRuleInsDetObj.componentTypeLabel__c='Flags for Inclusion / Exclusion and Other Fields';
        insert sceRuleInsDetObj;
        
         Scenario_Rule_Instance_Details__c sceRuleInsDetObj1 = new Scenario_Rule_Instance_Details__c ();
        sceRuleInsDetObj1.Scenario_Id__c= scenarioObj.id;
        sceRuleInsDetObj1.componentTypeLabel__c='Flags for Inclusion / Exclusion and Other Fields';
        insert sceRuleInsDetObj1;
        
        Data_Set_Rule_Map__c dataSetRuleObj = new Data_Set_Rule_Map__c();
        dataSetRuleObj.scenario_rule_instance_id__c=sceRuleInsDetObj.id;
        dataSetRuleObj.ds_type__c='i';
        insert dataSetRuleObj;
        
        Data_Set_Rule_Map__c dataSetRuleObj1 = new Data_Set_Rule_Map__c();
        dataSetRuleObj1.scenario_rule_instance_id__c=sceRuleInsDetObj.id;
        dataSetRuleObj1.ds_type__c='o';
        insert dataSetRuleObj1;
        
        system.debug('==dataSetRuleObj===='+dataSetRuleObj);
        
        ComponentTypeMaster__c ComTypeMasObj = new ComponentTypeMaster__c();
        ComTypeMasObj.Name='Call Balancing';
        ComTypeMasObj.Component_Definition__c='CPGDerivedFieldsList';
        ComTypeMasObj.DisplayIcon__c='add';
        ComTypeMasObj.DisplayIconClass__c='window information';
        insert ComTypeMasObj;
        
        Business_Rule_Type_Master__c busRuleTypeMasObj = new Business_Rule_Type_Master__c();
        busRuleTypeMasObj.Name='Rank';
        busRuleTypeMasObj.Component_Type__c=ComTypeMasObj.id;
        insert busRuleTypeMasObj;
        
        ComponentTypeMaster__c ComTypeMasObj1 = new ComponentTypeMaster__c();
        ComTypeMasObj1.Name='Aggregation';
        ComTypeMasObj1.Component_Definition__c='CPGDerivedFieldsList';
        ComTypeMasObj1.DisplayIcon__c='add';
        ComTypeMasObj1.DisplayIconClass__c='window information';
        insert ComTypeMasObj1;
        
        Business_Rule_Type_Master__c busRuleTypeMasObj1 = new Business_Rule_Type_Master__c();
        busRuleTypeMasObj1.Name='Rank';
        busRuleTypeMasObj1.Component_Type__c=ComTypeMasObj1.id;
        insert busRuleTypeMasObj1;
        
        Business_Rule_Type_Master__c busRuleTypeMasObj2 = new Business_Rule_Type_Master__c();
        busRuleTypeMasObj2.Name='Filter';
        busRuleTypeMasObj2.Component_Type__c=ComTypeMasObj1.id;
        insert busRuleTypeMasObj2;
        
        Business_Rules__c busRuleObj = new Business_Rules__c();
        busRuleObj.Name='Rank rule 278';
        busRuleObj.Business_Rule_Type_Master__c=busRuleTypeMasObj.id;
        busRuleObj.ScenarioRuleInstanceDetails__c=sceRuleInsDetObj.id;
        busRuleObj.Aggregate_Level__c='Test';
        busRuleObj.customer_prioritization__c='Test';
        insert busRuleObj;
        
        Business_Rule_FieldMap_Details__c busRuleFieldObj = new Business_Rule_FieldMap_Details__c();
        busRuleFieldObj.Param_Name__c='derived field 278';
        busRuleFieldObj.Business_Rule__c=busRuleObj.id;
        busRuleFieldObj.Param_Data_Type__c='Numeric';
        busRuleFieldObj.Param_Type__c='Derived';
        busRuleFieldObj.IO_Flag__c='O';
        
        insert busRuleFieldObj;
        
        Computation_Rule_Detail__c compRuleDetObj = new Computation_Rule_Detail__c();
        compRuleDetObj.Business_Rules__c=busRuleObj.id;
        compRuleDetObj.Data_Type__c='Numeric';
        compRuleDetObj.Derived_field_name__c='FIELD 123';
        
        insert compRuleDetObj;
        
        Data_Set__c dataSetObj = new Data_Set__c();
        dataSetObj.Name = 'Call Plan Summary';
        insert dataSetObj;
        
        Data_Set_Column_Detail__c dataSetCol = new Data_Set_Column_Detail__c();
        dataSetCol.dataset_id__c=dataSetObj.id;
        dataSetCol.variable_type__c='Derived';
        dataSetCol.ds_col_name__c='colTest';
        insert dataSetCol;
        
        list<Data_Set_Column_Detail__c> dataSetColDetList = new list<Data_Set_Column_Detail__c>();
        dataSetColDetList.add(dataSetCol);
        
        Filter_Rule_Entity_Detail__c filterRuleEntityblockObj = new Filter_Rule_Entity_Detail__c();
        filterRuleEntityblockObj.Business_Rules__c =busRuleObj.Id;
        filterRuleEntityblockObj.Category_Type__c ='If';
        filterRuleEntityblockObj.Entity_Type__c='Group';
        filterRuleEntityblockObj.Priority__c=1;
        insert filterRuleEntityblockObj;

        Filter_Rule_Entity_Detail__c filterRuleEntityGrpObj = new Filter_Rule_Entity_Detail__c();
        filterRuleEntityGrpObj.Business_Rules__c =busRuleObj.Id;
        filterRuleEntityGrpObj.Category_Type__c ='';
        filterRuleEntityGrpObj.Entity_Type__c='Group';
        filterRuleEntityGrpObj.Priority__c=1;
        insert filterRuleEntityGrpObj;

        Filter_Rule_Criteria_Detail__c filterRuleCriteriaObj = new Filter_Rule_Criteria_Detail__c();
        filterRuleCriteriaObj.Criteria_operator__c = 'in';
        filterRuleCriteriaObj.FieldDataType__c = 'Numeric';
        filterRuleCriteriaObj.Filter_Field_Name__c = 'gattex_tier';
        filterRuleCriteriaObj.Logic_operator__c = 'OR';
        filterRuleCriteriaObj.Param_value__c ='0';
        filterRuleCriteriaObj.Sequence__c ='1';
        filterRuleCriteriaObj.Filter_Rule_Entity_Detail__c=filterRuleEntityGrpObj.Id;
        insert filterRuleCriteriaObj;
     
        BRWrapBlock brwrapBlock = new BRWrapBlock();
        brwrapBlock.ruleName = 'test wrapBlock';
        //brwrapBlock.priority = '4,5';
        brwrapBlock.selPriority = 5;
        brwrapBlock.seq = 5;
        brwrapBlock.criteriaSeq = 5;
        brwrapBlock.criteriaLogic = 'Logic';
        brwrapBlock.executionLogic = 'Logic';
        //brwrapBlock.lstWrapGroup
        //brwrapBlock.lstOutputCriteria
        //brwrapBlock.lstElseCriteria
        //insert brwrapBlock;
        
        
        Test.startTest();
        
       /* String[] strArr = CPGFilterCtrl.getDataOptions('Numeric');
        String[] strArr1 = CPGFilterCtrl.getDataOptions('Text');
        List<Scenario_Rule_Instance_Details__c> sceRuleList = CPGFilterCtrl.getScenarioID(sceRuleInsDetObj.id);
        String[] strArr2 = CPGFilterCtrl.getOperators('Numeric');
        String[] strArr3 = CPGFilterCtrl.getOperators('Text');
        string getInputStr = CPGFilterCtrl.getInputTableName(sceRuleInsDetObj.id);
        string getInputStr1 = CPGFilterCtrl.getOutputTableName(sceRuleInsDetObj.id);
        //string wrapperData= '[{"criName":"-","criNameOptions":["-"],"fieldName":[{"ds_col_name__c":"TerrCallConstraint","column_id__c":"DSCD152892","datatype__c":"Text","dataset_id__c":"a1af4000000hIhtAAE","value_type__c":"Discrete","variable_type__c":"Derived","Table_Data_Type__c":"text","tb_col_nm__c":"terrcallconstraint","Id":"a1bf4000000d4nyAAA"},{"ds_col_name__c":"TerrTargetConstraint","column_id__c":"DSCD152893","datatype__c":"Text","dataset_id__c":"a1af4000000hIhtAAE","value_type__c":"Discrete","variable_type__c":"Derived","Table_Data_Type__c":"numeric","tb_col_nm__c":"terrtargetconstraint","Id":"a1bf4000000d4nzAAA"},{"ds_col_name__c":"TerrTargets","column_id__c":"DSCD153490","datatype__c":"Numeric","dataset_id__c":"a1af4000000hIhtAAE","value_type__c":"Continous","variable_type__c":"Derived","Table_Data_Type__c":"numeric","tb_col_nm__c":"terrtargets","Id":"a1bf4000000d4zVAAQ"},{"ds_col_name__c":"TerrCalls","column_id__c":"DSCD153491","datatype__c":"Numeric","dataset_id__c":"a1af4000000hIhtAAE","value_type__c":"Continous","variable_type__c":"Derived","Table_Data_Type__c":"numeric","tb_col_nm__c":"terrcalls","Id":"a1bf4000000d4zWAAQ"},{"ds_col_name__c":"territory_ID","column_id__c":"DSCD153492","datatype__c":"Text","dataset_id__c":"a1af4000000hIhtAAE","value_type__c":"Discrete","variable_type__c":"Derived","Table_Data_Type__c":"text","tb_col_nm__c":"territory_id","Id":"a1bf4000000d4zXAAQ"}],"fieldVal":"80","opVal":["equals","not equals","in","not in","is null","is not null","less than","less or equal","greater than","greater or equal","ends with","between"],"priority":["1"],"selFieldName":"0@0@1@Numeric@TerrTargets@null","selOpVal":"0@0@1@<","seqNo":1,"selPriority":"1"}]';
        //String columndata= '[{"Name":"TestColumnName","variabletype":"Derived","tableDataType":"Text","tableColumnName":"TestTableCOlName","colDatatype":"Text","colValuetype":"Derived","statusFlag":true}]';
        String columndata= '[{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgpcAAA","Name":"gattexlead_flag","statusFlag":false,"tableColumnName":"gattexlead_flag","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgpeAAA","Name":"SHIRE_ID","statusFlag":false,"tableColumnName":"shire_id","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Text","colValuetype":"Discrete","Id":"a1bf4000000dgpfAAA","Name":"Master tier","statusFlag":false,"tableColumnName":"master_tier","tableDataType":"text","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgpgAAA","Name":"callactivity_flag","statusFlag":true,"tableColumnName":"callactivity_flag","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgphAAA","Name":"REMS_FLG","statusFlag":true,"tableColumnName":"rems_flg","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Text","colValuetype":"Discrete","Id":"a1bf4000000dgpiAAA","Name":"ZIP","statusFlag":true,"tableColumnName":"zip","tableDataType":"text","variabletype":"Source"},{"colDatatype":"Text","colValuetype":"Discrete","Id":"a1bf4000000dgpjAAA","Name":"SPECIALTY_CODE","statusFlag":true,"tableColumnName":"specialty_code","tableDataType":"text","variabletype":"Source"},{"colDatatype":"Text","colValuetype":"Discrete","Id":"a1bf4000000dgpkAAA","Name":"PROF_TYPE","statusFlag":true,"tableColumnName":"prof_type","tableDataType":"text","variabletype":"Source"},{"colDatatype":"Text","colValuetype":"Discrete","Id":"a1bf4000000dgplAAA","Name":"PROF_SUBTYPE","statusFlag":true,"tableColumnName":"prof_subtype","tableDataType":"text","variabletype":"Source"},{"colDatatype":"Text","colValuetype":"Discrete","Id":"a1bf4000000dgpmAAA","Name":"PROF_STATUS","statusFlag":true,"tableColumnName":"prof_status","tableDataType":"text","variabletype":"Source"},{"colDatatype":"Text","colValuetype":"Discrete","Id":"a1bf4000000dgpnAAA","Name":"SF_EXCLUSION","statusFlag":true,"tableColumnName":"sf_exclusion","tableDataType":"text","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgpoAAA","Name":"NO_SAMPLE","statusFlag":true,"tableColumnName":"no_sample","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgppAAA","Name":"NO_ACCESS","statusFlag":true,"tableColumnName":"no_access","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgpqAAA","Name":"HR_EXCLUSION","statusFlag":true,"tableColumnName":"hr_exclusion","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgprAAA","Name":"RUL","statusFlag":true,"tableColumnName":"rul","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgpsAAA","Name":"Gattex_XS_Final","statusFlag":true,"tableColumnName":"gattex_xs_final","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgptAAA","Name":"Gattex_XT","statusFlag":true,"tableColumnName":"gattex_xt","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Text","colValuetype":"Discrete","Id":"a1bf4000000dgpuAAA","Name":"territory_ID","statusFlag":true,"tableColumnName":"territory_id","tableDataType":"text","variabletype":"Source"},{"colDatatype":"Text","colValuetype":"Discrete","Id":"a1bf4000000dgpvAAA","Name":"GATTEX CALL PLAN ELIGIBLE FLAG","statusFlag":false,"tableColumnName":"gattex_call_plan_eligible_flag","tableDataType":"text","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgpxAAA","Name":"targettype_flag","statusFlag":true,"tableColumnName":"targettype_flag","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Continuous","Id":"a1bf4000000dgqkAAA","Name":"comp_name","statusFlag":false,"tableColumnName":"comp_name","tableDataType":"numeric","variabletype":"Derived"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dhIxAAI","Name":"frcomp1","statusFlag":true,"tableColumnName":"frcomp1","tableDataType":"numeric","variabletype":"Derived"},{"colDatatype":"Numeric","colValuetype":"Continuous","Id":"a1bf4000000dhqeAAA","Name":"fff1","statusFlag":false,"tableColumnName":"fff1","tableDataType":"numeric","variabletype":"Derived"},{"colDatatype":"Numeric","colValuetype":"Continuous","Id":"a1bf4000000dhyPAAQ","Name":"pp","statusFlag":true,"tableColumnName":"pp","tableDataType":"numeric","variabletype":"Derived"},{"colDatatype":"Numeric","colValuetype":"Continuous","Id":"a1bf4000000dhzVAAQ","Name":"f1cat","statusFlag":true,"tableColumnName":"f1cat","tableDataType":"numeric","variabletype":"Derived"},{"colDatatype":"Numeric","colValuetype":"Continuous","Id":"a1bf4000000dlYXAAY","Name":"f1","statusFlag":true,"tableColumnName":"f1","tableDataType":"numeric","variabletype":"Derived"}]';
        string wrapperData= '[{"criteriaLogic":"(1 OR 2 OR 3) AND (4)","lstWrapGroup":[{"lstwrapCriteria":[{"criName":"-","criNameOptions":["-"],"fieldName":[{"dataType":"Numeric","dsColName":"gattexlead_flag","tblColName":"gattexlead_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"SHIRE_ID","tblColName":"shire_id","variableType":"Source"},{"dataType":"Text","dsColName":"Master tier","tblColName":"master_tier","variableType":"Source"},{"dataType":"Numeric","dsColName":"callactivity_flag","tblColName":"callactivity_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"REMS_FLG","tblColName":"rems_flg","variableType":"Source"},{"dataType":"Text","dsColName":"ZIP","tblColName":"zip","variableType":"Source"},{"dataType":"Text","dsColName":"SPECIALTY_CODE","tblColName":"specialty_code","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_TYPE","tblColName":"prof_type","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_SUBTYPE","tblColName":"prof_subtype","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_STATUS","tblColName":"prof_status","variableType":"Source"},{"dataType":"Text","dsColName":"SF_EXCLUSION","tblColName":"sf_exclusion","variableType":"Source"},{"dataType":"Numeric","dsColName":"NO_SAMPLE","tblColName":"no_sample","variableType":"Source"},{"dataType":"Numeric","dsColName":"NO_ACCESS","tblColName":"no_access","variableType":"Source"},{"dataType":"Numeric","dsColName":"HR_EXCLUSION","tblColName":"hr_exclusion","variableType":"Source"},{"dataType":"Numeric","dsColName":"RUL","tblColName":"rul","variableType":"Source"},{"dataType":"Numeric","dsColName":"Gattex_XS_Final","tblColName":"gattex_xs_final","variableType":"Source"},{"dataType":"Numeric","dsColName":"Gattex_XT","tblColName":"gattex_xt","variableType":"Source"},{"dataType":"Text","dsColName":"territory_ID","tblColName":"territory_id","variableType":"Source"},{"dataType":"Text","dsColName":"GATTEX CALL PLAN ELIGIBLE FLAG","tblColName":"gattex_call_plan_eligible_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"targettype_flag","tblColName":"targettype_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"comp_name","tblColName":"comp_name","variableType":"Derived"},{"dataType":"Numeric","dsColName":"frcomp1","tblColName":"frcomp1","variableType":"Derived"},{"dataType":"Numeric","dsColName":"fff1","tblColName":"fff1","variableType":"Derived"},{"dataType":"Numeric","dsColName":"pp","tblColName":"pp","variableType":"Derived"},{"dataType":"Numeric","dsColName":"f1cat","tblColName":"f1cat","variableType":"Derived"},{"dataType":"Numeric","dsColName":"f1","tblColName":"f1","variableType":"Derived"}],"fieldVal":"TIER 1, TIER 2,TIER 3, PROSPECT","opVal":["equals","not equals","in","not in","contains","does not contains","begins with","ends with","is null","is not null"],"selFieldName":"0@0@0@Text@master_tier@Source","selOpVal":"0@0@0@in","seqNo":1},{"criName":"OR","criNameOptions":["AND","OR"],"fieldName":[{"dataType":"Numeric","dsColName":"gattexlead_flag","tblColName":"gattexlead_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"SHIRE_ID","tblColName":"shire_id","variableType":"Source"},{"dataType":"Text","dsColName":"Master tier","tblColName":"master_tier","variableType":"Source"},{"dataType":"Numeric","dsColName":"callactivity_flag","tblColName":"callactivity_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"REMS_FLG","tblColName":"rems_flg","variableType":"Source"},{"dataType":"Text","dsColName":"ZIP","tblColName":"zip","variableType":"Source"},{"dataType":"Text","dsColName":"SPECIALTY_CODE","tblColName":"specialty_code","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_TYPE","tblColName":"prof_type","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_SUBTYPE","tblColName":"prof_subtype","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_STATUS","tblColName":"prof_status","variableType":"Source"},{"dataType":"Text","dsColName":"SF_EXCLUSION","tblColName":"sf_exclusion","variableType":"Source"},{"dataType":"Numeric","dsColName":"NO_SAMPLE","tblColName":"no_sample","variableType":"Source"},{"dataType":"Numeric","dsColName":"NO_ACCESS","tblColName":"no_access","variableType":"Source"},{"dataType":"Numeric","dsColName":"HR_EXCLUSION","tblColName":"hr_exclusion","variableType":"Source"},{"dataType":"Numeric","dsColName":"RUL","tblColName":"rul","variableType":"Source"},{"dataType":"Numeric","dsColName":"Gattex_XS_Final","tblColName":"gattex_xs_final","variableType":"Source"},{"dataType":"Numeric","dsColName":"Gattex_XT","tblColName":"gattex_xt","variableType":"Source"},{"dataType":"Text","dsColName":"territory_ID","tblColName":"territory_id","variableType":"Source"},{"dataType":"Text","dsColName":"GATTEX CALL PLAN ELIGIBLE FLAG","tblColName":"gattex_call_plan_eligible_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"targettype_flag","tblColName":"targettype_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"comp_name","tblColName":"comp_name","variableType":"Derived"},{"dataType":"Numeric","dsColName":"frcomp1","tblColName":"frcomp1","variableType":"Derived"},{"dataType":"Numeric","dsColName":"fff1","tblColName":"fff1","variableType":"Derived"},{"dataType":"Numeric","dsColName":"pp","tblColName":"pp","variableType":"Derived"},{"dataType":"Numeric","dsColName":"f1cat","tblColName":"f1cat","variableType":"Derived"},{"dataType":"Numeric","dsColName":"f1","tblColName":"f1","variableType":"Derived"}],"fieldVal":"1","opVal":["equals","not equals","in","not in","greater than","greater or equal","less than","less or equal","between","is null","is not null"],"selFieldName":"1@0@0@Numeric@gattexlead_flag@Source","selOpVal":"1@0@0@equals","seqNo":2},{"criName":"OR","criNameOptions":["AND","OR"],"fieldName":[{"dataType":"Numeric","dsColName":"gattexlead_flag","tblColName":"gattexlead_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"SHIRE_ID","tblColName":"shire_id","variableType":"Source"},{"dataType":"Text","dsColName":"Master tier","tblColName":"master_tier","variableType":"Source"},{"dataType":"Numeric","dsColName":"callactivity_flag","tblColName":"callactivity_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"REMS_FLG","tblColName":"rems_flg","variableType":"Source"},{"dataType":"Text","dsColName":"ZIP","tblColName":"zip","variableType":"Source"},{"dataType":"Text","dsColName":"SPECIALTY_CODE","tblColName":"specialty_code","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_TYPE","tblColName":"prof_type","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_SUBTYPE","tblColName":"prof_subtype","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_STATUS","tblColName":"prof_status","variableType":"Source"},{"dataType":"Text","dsColName":"SF_EXCLUSION","tblColName":"sf_exclusion","variableType":"Source"},{"dataType":"Numeric","dsColName":"NO_SAMPLE","tblColName":"no_sample","variableType":"Source"},{"dataType":"Numeric","dsColName":"NO_ACCESS","tblColName":"no_access","variableType":"Source"},{"dataType":"Numeric","dsColName":"HR_EXCLUSION","tblColName":"hr_exclusion","variableType":"Source"},{"dataType":"Numeric","dsColName":"RUL","tblColName":"rul","variableType":"Source"},{"dataType":"Numeric","dsColName":"Gattex_XS_Final","tblColName":"gattex_xs_final","variableType":"Source"},{"dataType":"Numeric","dsColName":"Gattex_XT","tblColName":"gattex_xt","variableType":"Source"},{"dataType":"Text","dsColName":"territory_ID","tblColName":"territory_id","variableType":"Source"},{"dataType":"Text","dsColName":"GATTEX CALL PLAN ELIGIBLE FLAG","tblColName":"gattex_call_plan_eligible_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"targettype_flag","tblColName":"targettype_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"comp_name","tblColName":"comp_name","variableType":"Derived"},{"dataType":"Numeric","dsColName":"frcomp1","tblColName":"frcomp1","variableType":"Derived"},{"dataType":"Numeric","dsColName":"fff1","tblColName":"fff1","variableType":"Derived"},{"dataType":"Numeric","dsColName":"pp","tblColName":"pp","variableType":"Derived"},{"dataType":"Numeric","dsColName":"f1cat","tblColName":"f1cat","variableType":"Derived"},{"dataType":"Numeric","dsColName":"f1","tblColName":"f1","variableType":"Derived"}],"fieldVal":"1","opVal":["equals","not equals","in","not in","greater than","greater or equal","less than","less or equal","between","is null","is not null"],"selFieldName":"2@0@0@Numeric@f1@Derived","selOpVal":"2@0@0@equals","seqNo":3}]},{"lstwrapCriteria":[{"criName":"-","criNameOptions":["-"],"fieldName":[{"dataType":"Numeric","dsColName":"gattexlead_flag","tblColName":"gattexlead_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"SHIRE_ID","tblColName":"shire_id","variableType":"Source"},{"dataType":"Text","dsColName":"Master tier","tblColName":"master_tier","variableType":"Source"},{"dataType":"Numeric","dsColName":"callactivity_flag","tblColName":"callactivity_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"REMS_FLG","tblColName":"rems_flg","variableType":"Source"},{"dataType":"Text","dsColName":"ZIP","tblColName":"zip","variableType":"Source"},{"dataType":"Text","dsColName":"SPECIALTY_CODE","tblColName":"specialty_code","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_TYPE","tblColName":"prof_type","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_SUBTYPE","tblColName":"prof_subtype","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_STATUS","tblColName":"prof_status","variableType":"Source"},{"dataType":"Text","dsColName":"SF_EXCLUSION","tblColName":"sf_exclusion","variableType":"Source"},{"dataType":"Numeric","dsColName":"NO_SAMPLE","tblColName":"no_sample","variableType":"Source"},{"dataType":"Numeric","dsColName":"NO_ACCESS","tblColName":"no_access","variableType":"Source"},{"dataType":"Numeric","dsColName":"HR_EXCLUSION","tblColName":"hr_exclusion","variableType":"Source"},{"dataType":"Numeric","dsColName":"RUL","tblColName":"rul","variableType":"Source"},{"dataType":"Numeric","dsColName":"Gattex_XS_Final","tblColName":"gattex_xs_final","variableType":"Source"},{"dataType":"Numeric","dsColName":"Gattex_XT","tblColName":"gattex_xt","variableType":"Source"},{"dataType":"Text","dsColName":"territory_ID","tblColName":"territory_id","variableType":"Source"},{"dataType":"Text","dsColName":"GATTEX CALL PLAN ELIGIBLE FLAG","tblColName":"gattex_call_plan_eligible_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"targettype_flag","tblColName":"targettype_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"comp_name","tblColName":"comp_name","variableType":"Derived"},{"dataType":"Numeric","dsColName":"frcomp1","tblColName":"frcomp1","variableType":"Derived"},{"dataType":"Numeric","dsColName":"fff1","tblColName":"fff1","variableType":"Derived"},{"dataType":"Numeric","dsColName":"pp","tblColName":"pp","variableType":"Derived"},{"dataType":"Numeric","dsColName":"f1cat","tblColName":"f1cat","variableType":"Derived"},{"dataType":"Numeric","dsColName":"f1","tblColName":"f1","variableType":"Derived"}],"fieldVal":"2","opVal":["equals","not equals","in","not in","greater than","greater or equal","less than","less or equal","between","is null","is not null"],"selFieldName":"0@1@0@Numeric@gattexlead_flag@Source","selOpVal":"0@1@0@not in","seqNo":4}],"selGroupOp":"AND"}],"priority":[1],"selPriority":1}]'; 
        BROutputCriteria outCri1 = CPGFilterCtrl.AddDynamicData('','categName','Numeric','Discrete','1,0');
        BROutputCriteria outCri2 = CPGFilterCtrl.AddDynamicData('','cat1','Numeric','Continous','values');
        List<Business_Rule_Type_Master__c> busRUleTypeList = CPGFilterCtrl.getBusinessRuleTypeMaster(ComTypeMasObj.id);
        list<BRColumnWrapper> colWrapList = CPGFilterCtrl.CreateColumnWrapper(sceRuleInsDetObj.id);
        List<BRWrapBlock> wrapList = CPGFilterCtrl.initialiseBlock(sceRuleInsDetObj.id);
        List<BRWrapBlock> wrapList1 = CPGFilterCtrl.InitialiseRule(busRuleObj.id,sceRuleInsDetObj.id);
        BRWrapBlock.WrapGroup wrapGrp = CPGFilterCtrl.AddGroup(true,sceRuleInsDetObj.id);
        BRWrapBlock wrapBlck1 = CPGFilterCtrl.AddBlock(true,sceRuleInsDetObj.id);
        string str5 = CPGFilterCtrl.getRuleName(sceRuleInsDetObj.id);
        list<BRColumnWrapper> colWrap5 = CPGFilterCtrl.getColumns(sceRuleInsDetObj.id);
        Filter_Rule_Criteria_Detail__c filRuleCri = new Filter_Rule_Criteria_Detail__c();
        filRuleCri.Sequence__c='1';
        insert filRuleCri;
        BRWrapCriteria wrapCri = CPGFilterCtrl.CreateCriteria(filRuleCri,1,1,1,sceRuleInsDetObj.id);
        BRWrapBlock.WrapGroup wrapGrp2 = CPGFilterCtrl.AddAGroup(sceRuleInsDetObj.id);
        BRWrapCriteria wrapCri2 = CPGFilterCtrl.AddCriteria(sceRuleInsDetObj.id);
        //BRWrapBlock.WrapGroup wrapGrp1 = CPGFilterCtrl.CreateGroup(true,sceRuleInsDetObj.id);
        string busRUleStr = CPGFilterCtrl.getBusinessRuleId(sceRuleInsDetObj.id);
        Id saveBusId = CPGFilterCtrl.SaveBusinessRule('testBusName',sceRuleInsDetObj.id);
         
        string str = CPGFilterCtrl.SaveCheck('Test Rule Name',wrapperData,sceRuleInsDetObj.id,'componentId',columndata); */
        string wrapperData= '[{"criteriaLogic":"(1 OR 2 OR 3) AND (4)","lstWrapGroup":[{"lstwrapCriteria":[{"criName":"-","criNameOptions":["-"],"fieldName":[{"dataType":"Numeric","dsColName":"gattexlead_flag","tblColName":"gattexlead_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"SHIRE_ID","tblColName":"shire_id","variableType":"Source"},{"dataType":"Text","dsColName":"Master tier","tblColName":"master_tier","variableType":"Source"},{"dataType":"Numeric","dsColName":"callactivity_flag","tblColName":"callactivity_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"REMS_FLG","tblColName":"rems_flg","variableType":"Source"},{"dataType":"Text","dsColName":"ZIP","tblColName":"zip","variableType":"Source"},{"dataType":"Text","dsColName":"SPECIALTY_CODE","tblColName":"specialty_code","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_TYPE","tblColName":"prof_type","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_SUBTYPE","tblColName":"prof_subtype","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_STATUS","tblColName":"prof_status","variableType":"Source"},{"dataType":"Text","dsColName":"SF_EXCLUSION","tblColName":"sf_exclusion","variableType":"Source"},{"dataType":"Numeric","dsColName":"NO_SAMPLE","tblColName":"no_sample","variableType":"Source"},{"dataType":"Numeric","dsColName":"NO_ACCESS","tblColName":"no_access","variableType":"Source"},{"dataType":"Numeric","dsColName":"HR_EXCLUSION","tblColName":"hr_exclusion","variableType":"Source"},{"dataType":"Numeric","dsColName":"RUL","tblColName":"rul","variableType":"Source"},{"dataType":"Numeric","dsColName":"Gattex_XS_Final","tblColName":"gattex_xs_final","variableType":"Source"},{"dataType":"Numeric","dsColName":"Gattex_XT","tblColName":"gattex_xt","variableType":"Source"},{"dataType":"Text","dsColName":"territory_ID","tblColName":"territory_id","variableType":"Source"},{"dataType":"Text","dsColName":"GATTEX CALL PLAN ELIGIBLE FLAG","tblColName":"gattex_call_plan_eligible_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"targettype_flag","tblColName":"targettype_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"comp_name","tblColName":"comp_name","variableType":"Derived"},{"dataType":"Numeric","dsColName":"frcomp1","tblColName":"frcomp1","variableType":"Derived"},{"dataType":"Numeric","dsColName":"fff1","tblColName":"fff1","variableType":"Derived"},{"dataType":"Numeric","dsColName":"pp","tblColName":"pp","variableType":"Derived"},{"dataType":"Numeric","dsColName":"f1cat","tblColName":"f1cat","variableType":"Derived"},{"dataType":"Numeric","dsColName":"f1","tblColName":"f1","variableType":"Derived"}],"fieldVal":"TIER 1, TIER 2,TIER 3, PROSPECT","opVal":["equals","not equals","in","not in","contains","does not contains","begins with","ends with","is null","is not null"],"selFieldName":"0@0@0@Text@master_tier@Source","selOpVal":"0@0@0@in","seqNo":1},{"criName":"OR","criNameOptions":["AND","OR"],"fieldName":[{"dataType":"Numeric","dsColName":"gattexlead_flag","tblColName":"gattexlead_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"SHIRE_ID","tblColName":"shire_id","variableType":"Source"},{"dataType":"Text","dsColName":"Master tier","tblColName":"master_tier","variableType":"Source"},{"dataType":"Numeric","dsColName":"callactivity_flag","tblColName":"callactivity_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"REMS_FLG","tblColName":"rems_flg","variableType":"Source"},{"dataType":"Text","dsColName":"ZIP","tblColName":"zip","variableType":"Source"},{"dataType":"Text","dsColName":"SPECIALTY_CODE","tblColName":"specialty_code","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_TYPE","tblColName":"prof_type","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_SUBTYPE","tblColName":"prof_subtype","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_STATUS","tblColName":"prof_status","variableType":"Source"},{"dataType":"Text","dsColName":"SF_EXCLUSION","tblColName":"sf_exclusion","variableType":"Source"},{"dataType":"Numeric","dsColName":"NO_SAMPLE","tblColName":"no_sample","variableType":"Source"},{"dataType":"Numeric","dsColName":"NO_ACCESS","tblColName":"no_access","variableType":"Source"},{"dataType":"Numeric","dsColName":"HR_EXCLUSION","tblColName":"hr_exclusion","variableType":"Source"},{"dataType":"Numeric","dsColName":"RUL","tblColName":"rul","variableType":"Source"},{"dataType":"Numeric","dsColName":"Gattex_XS_Final","tblColName":"gattex_xs_final","variableType":"Source"},{"dataType":"Numeric","dsColName":"Gattex_XT","tblColName":"gattex_xt","variableType":"Source"},{"dataType":"Text","dsColName":"territory_ID","tblColName":"territory_id","variableType":"Source"},{"dataType":"Text","dsColName":"GATTEX CALL PLAN ELIGIBLE FLAG","tblColName":"gattex_call_plan_eligible_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"targettype_flag","tblColName":"targettype_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"comp_name","tblColName":"comp_name","variableType":"Derived"},{"dataType":"Numeric","dsColName":"frcomp1","tblColName":"frcomp1","variableType":"Derived"},{"dataType":"Numeric","dsColName":"fff1","tblColName":"fff1","variableType":"Derived"},{"dataType":"Numeric","dsColName":"pp","tblColName":"pp","variableType":"Derived"},{"dataType":"Numeric","dsColName":"f1cat","tblColName":"f1cat","variableType":"Derived"},{"dataType":"Numeric","dsColName":"f1","tblColName":"f1","variableType":"Derived"}],"fieldVal":"1","opVal":["equals","not equals","in","not in","greater than","greater or equal","less than","less or equal","between","is null","is not null"],"selFieldName":"1@0@0@Numeric@gattexlead_flag@Source","selOpVal":"1@0@0@equals","seqNo":2},{"criName":"OR","criNameOptions":["AND","OR"],"fieldName":[{"dataType":"Numeric","dsColName":"gattexlead_flag","tblColName":"gattexlead_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"SHIRE_ID","tblColName":"shire_id","variableType":"Source"},{"dataType":"Text","dsColName":"Master tier","tblColName":"master_tier","variableType":"Source"},{"dataType":"Numeric","dsColName":"callactivity_flag","tblColName":"callactivity_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"REMS_FLG","tblColName":"rems_flg","variableType":"Source"},{"dataType":"Text","dsColName":"ZIP","tblColName":"zip","variableType":"Source"},{"dataType":"Text","dsColName":"SPECIALTY_CODE","tblColName":"specialty_code","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_TYPE","tblColName":"prof_type","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_SUBTYPE","tblColName":"prof_subtype","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_STATUS","tblColName":"prof_status","variableType":"Source"},{"dataType":"Text","dsColName":"SF_EXCLUSION","tblColName":"sf_exclusion","variableType":"Source"},{"dataType":"Numeric","dsColName":"NO_SAMPLE","tblColName":"no_sample","variableType":"Source"},{"dataType":"Numeric","dsColName":"NO_ACCESS","tblColName":"no_access","variableType":"Source"},{"dataType":"Numeric","dsColName":"HR_EXCLUSION","tblColName":"hr_exclusion","variableType":"Source"},{"dataType":"Numeric","dsColName":"RUL","tblColName":"rul","variableType":"Source"},{"dataType":"Numeric","dsColName":"Gattex_XS_Final","tblColName":"gattex_xs_final","variableType":"Source"},{"dataType":"Numeric","dsColName":"Gattex_XT","tblColName":"gattex_xt","variableType":"Source"},{"dataType":"Text","dsColName":"territory_ID","tblColName":"territory_id","variableType":"Source"},{"dataType":"Text","dsColName":"GATTEX CALL PLAN ELIGIBLE FLAG","tblColName":"gattex_call_plan_eligible_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"targettype_flag","tblColName":"targettype_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"comp_name","tblColName":"comp_name","variableType":"Derived"},{"dataType":"Numeric","dsColName":"frcomp1","tblColName":"frcomp1","variableType":"Derived"},{"dataType":"Numeric","dsColName":"fff1","tblColName":"fff1","variableType":"Derived"},{"dataType":"Numeric","dsColName":"pp","tblColName":"pp","variableType":"Derived"},{"dataType":"Numeric","dsColName":"f1cat","tblColName":"f1cat","variableType":"Derived"},{"dataType":"Numeric","dsColName":"f1","tblColName":"f1","variableType":"Derived"}],"fieldVal":"1","opVal":["equals","not equals","in","not in","greater than","greater or equal","less than","less or equal","between","is null","is not null"],"selFieldName":"2@0@0@Numeric@f1@Derived","selOpVal":"2@0@0@equals","seqNo":3}]},{"lstwrapCriteria":[{"criName":"-","criNameOptions":["-"],"fieldName":[{"dataType":"Numeric","dsColName":"gattexlead_flag","tblColName":"gattexlead_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"SHIRE_ID","tblColName":"shire_id","variableType":"Source"},{"dataType":"Text","dsColName":"Master tier","tblColName":"master_tier","variableType":"Source"},{"dataType":"Numeric","dsColName":"callactivity_flag","tblColName":"callactivity_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"REMS_FLG","tblColName":"rems_flg","variableType":"Source"},{"dataType":"Text","dsColName":"ZIP","tblColName":"zip","variableType":"Source"},{"dataType":"Text","dsColName":"SPECIALTY_CODE","tblColName":"specialty_code","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_TYPE","tblColName":"prof_type","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_SUBTYPE","tblColName":"prof_subtype","variableType":"Source"},{"dataType":"Text","dsColName":"PROF_STATUS","tblColName":"prof_status","variableType":"Source"},{"dataType":"Text","dsColName":"SF_EXCLUSION","tblColName":"sf_exclusion","variableType":"Source"},{"dataType":"Numeric","dsColName":"NO_SAMPLE","tblColName":"no_sample","variableType":"Source"},{"dataType":"Numeric","dsColName":"NO_ACCESS","tblColName":"no_access","variableType":"Source"},{"dataType":"Numeric","dsColName":"HR_EXCLUSION","tblColName":"hr_exclusion","variableType":"Source"},{"dataType":"Numeric","dsColName":"RUL","tblColName":"rul","variableType":"Source"},{"dataType":"Numeric","dsColName":"Gattex_XS_Final","tblColName":"gattex_xs_final","variableType":"Source"},{"dataType":"Numeric","dsColName":"Gattex_XT","tblColName":"gattex_xt","variableType":"Source"},{"dataType":"Text","dsColName":"territory_ID","tblColName":"territory_id","variableType":"Source"},{"dataType":"Text","dsColName":"GATTEX CALL PLAN ELIGIBLE FLAG","tblColName":"gattex_call_plan_eligible_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"targettype_flag","tblColName":"targettype_flag","variableType":"Source"},{"dataType":"Numeric","dsColName":"comp_name","tblColName":"comp_name","variableType":"Derived"},{"dataType":"Numeric","dsColName":"frcomp1","tblColName":"frcomp1","variableType":"Derived"},{"dataType":"Numeric","dsColName":"fff1","tblColName":"fff1","variableType":"Derived"},{"dataType":"Numeric","dsColName":"pp","tblColName":"pp","variableType":"Derived"},{"dataType":"Numeric","dsColName":"f1cat","tblColName":"f1cat","variableType":"Derived"},{"dataType":"Numeric","dsColName":"f1","tblColName":"f1","variableType":"Derived"}],"fieldVal":"2","opVal":["equals","not equals","in","not in","greater than","greater or equal","less than","less or equal","between","is null","is not null"],"selFieldName":"0@1@0@Numeric@gattexlead_flag@Source","selOpVal":"0@1@0@not in","seqNo":4}],"selGroupOp":"AND"}],"priority":[1],"selPriority":1}]'; 
        String columndata= '[{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgpcAAA","Name":"gattexlead_flag","statusFlag":false,"tableColumnName":"gattexlead_flag","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgpeAAA","Name":"SHIRE_ID","statusFlag":false,"tableColumnName":"shire_id","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Text","colValuetype":"Discrete","Id":"a1bf4000000dgpfAAA","Name":"Master tier","statusFlag":false,"tableColumnName":"master_tier","tableDataType":"text","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgpgAAA","Name":"callactivity_flag","statusFlag":true,"tableColumnName":"callactivity_flag","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgphAAA","Name":"REMS_FLG","statusFlag":true,"tableColumnName":"rems_flg","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Text","colValuetype":"Discrete","Id":"a1bf4000000dgpiAAA","Name":"ZIP","statusFlag":true,"tableColumnName":"zip","tableDataType":"text","variabletype":"Source"},{"colDatatype":"Text","colValuetype":"Discrete","Id":"a1bf4000000dgpjAAA","Name":"SPECIALTY_CODE","statusFlag":true,"tableColumnName":"specialty_code","tableDataType":"text","variabletype":"Source"},{"colDatatype":"Text","colValuetype":"Discrete","Id":"a1bf4000000dgpkAAA","Name":"PROF_TYPE","statusFlag":true,"tableColumnName":"prof_type","tableDataType":"text","variabletype":"Source"},{"colDatatype":"Text","colValuetype":"Discrete","Id":"a1bf4000000dgplAAA","Name":"PROF_SUBTYPE","statusFlag":true,"tableColumnName":"prof_subtype","tableDataType":"text","variabletype":"Source"},{"colDatatype":"Text","colValuetype":"Discrete","Id":"a1bf4000000dgpmAAA","Name":"PROF_STATUS","statusFlag":true,"tableColumnName":"prof_status","tableDataType":"text","variabletype":"Source"},{"colDatatype":"Text","colValuetype":"Discrete","Id":"a1bf4000000dgpnAAA","Name":"SF_EXCLUSION","statusFlag":true,"tableColumnName":"sf_exclusion","tableDataType":"text","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgpoAAA","Name":"NO_SAMPLE","statusFlag":true,"tableColumnName":"no_sample","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgppAAA","Name":"NO_ACCESS","statusFlag":true,"tableColumnName":"no_access","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgpqAAA","Name":"HR_EXCLUSION","statusFlag":true,"tableColumnName":"hr_exclusion","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgprAAA","Name":"RUL","statusFlag":true,"tableColumnName":"rul","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgpsAAA","Name":"Gattex_XS_Final","statusFlag":true,"tableColumnName":"gattex_xs_final","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgptAAA","Name":"Gattex_XT","statusFlag":true,"tableColumnName":"gattex_xt","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Text","colValuetype":"Discrete","Id":"a1bf4000000dgpuAAA","Name":"territory_ID","statusFlag":true,"tableColumnName":"territory_id","tableDataType":"text","variabletype":"Source"},{"colDatatype":"Text","colValuetype":"Discrete","Id":"a1bf4000000dgpvAAA","Name":"GATTEX CALL PLAN ELIGIBLE FLAG","statusFlag":false,"tableColumnName":"gattex_call_plan_eligible_flag","tableDataType":"text","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dgpxAAA","Name":"targettype_flag","statusFlag":true,"tableColumnName":"targettype_flag","tableDataType":"numeric","variabletype":"Source"},{"colDatatype":"Numeric","colValuetype":"Continuous","Id":"a1bf4000000dgqkAAA","Name":"comp_name","statusFlag":false,"tableColumnName":"comp_name","tableDataType":"numeric","variabletype":"Derived"},{"colDatatype":"Numeric","colValuetype":"Discrete","Id":"a1bf4000000dhIxAAI","Name":"frcomp1","statusFlag":true,"tableColumnName":"frcomp1","tableDataType":"numeric","variabletype":"Derived"},{"colDatatype":"Numeric","colValuetype":"Continuous","Id":"a1bf4000000dhqeAAA","Name":"fff1","statusFlag":false,"tableColumnName":"fff1","tableDataType":"numeric","variabletype":"Derived"},{"colDatatype":"Numeric","colValuetype":"Continuous","Id":"a1bf4000000dhyPAAQ","Name":"pp","statusFlag":true,"tableColumnName":"pp","tableDataType":"numeric","variabletype":"Derived"},{"colDatatype":"Numeric","colValuetype":"Continuous","Id":"a1bf4000000dhzVAAQ","Name":"f1cat","statusFlag":true,"tableColumnName":"f1cat","tableDataType":"numeric","variabletype":"Derived"},{"colDatatype":"Numeric","colValuetype":"Continuous","Id":"a1bf4000000dlYXAAY","Name":"f1","statusFlag":true,"tableColumnName":"f1","tableDataType":"numeric","variabletype":"Derived"}]';
        BRReportsFilterCtrl obj =new BRReportsFilterCtrl();
        BRReportsFilterCtrl.getDataOptions('Text');
        BRReportsFilterCtrl.getDataOptions('Numeric');
        BRReportsFilterCtrl.getScenarioID(sceRuleInsDetObj.id);
        BRReportsFilterCtrl.getOperators('Text');
        BRReportsFilterCtrl.getOperators('Numeric');
        BRReportsFilterCtrl.getColumnsData(sceRuleInsDetObj.id);
        BRReportsFilterCtrl.getInputTableName(sceRuleInsDetObj.id);
        BRReportsFilterCtrl.getOutputTableName(sceRuleInsDetObj.id);
        BRReportsFilterCtrl.AddDynamicData('','categName','Numeric','Discrete','1,0');
        BRReportsFilterCtrl.AddDynamicData('','cat1','Numeric','Continous','values');
        BRReportsFilterCtrl.getBusinessRuleTypeMaster(ComTypeMasObj.id);
        BRReportsFilterCtrl.CreateColumnWrapper(sceRuleInsDetObj.id);
        BRReportsFilterCtrl.AddCriteria(sceRuleInsDetObj.id);
        BRReportsFilterCtrl.SaveCheck('Test Rule Name',wrapperData,sceRuleInsDetObj.id,'componentId',columndata);
        BRReportsFilterCtrl.getBusinessRuleId(sceRuleInsDetObj.id);
        //BRReportsFilterCtrl.UpdateBusinessRule(busRuleObj.id,'test');
        try{
            BRReportsFilterCtrl.SaveBusinessRule('Name',scenarioObj.id);
        }catch(Exception e){
            
        }
        
        //BRReportsFilterCtrl.deleteBusinessFilters('ID');
        BRReportsFilterCtrl.AddGroup(true,sceRuleInsDetObj.id);
        BRReportsFilterCtrl.AddBlock(true,sceRuleInsDetObj.id);
        BRReportsFilterCtrl.getRuleName(sceRuleInsDetObj.id);
        BRReportsFilterCtrl.getColumns(sceRuleInsDetObj.id);
        BRReportsFilterCtrl.initialiseBlock(sceRuleInsDetObj.id);
        BRReportsFilterCtrl.InitialiseRule(busRuleObj.id,sceRuleInsDetObj.id);
        //CreateBlock
       // BRReportsFilterCtrl.CreateGroup(true,sceRuleInsDetObj.id);
       // BRReportsFilterCtrl.CreateCriteria(filRuleCri,1,1,1,sceRuleInsDetObj.id);
        BRReportsFilterCtrl.AddAGroup(sceRuleInsDetObj.id);
        //BRReportsFilterCtrlAddCriteria(sceRuleInsDetObj.id);
        Test.stopTest(); 
        }
   
}